
/// 匹配得到的对象
class YHMatch {
  int start;
  int end;
  bool highlight;

  YHMatch(this.start, this.end, this.highlight);

  @override
  String toString() {
    return "start $start end $end highlight $highlight";
  }

  static List<YHMatch> regex(
      RegExp exp,
      String text,
      ) {
    final list = exp.allMatches(text);
    if (list.isEmpty) return [];
    List<YHMatch> matches = [];
    int start = list.first.start;
    int end = list.first.end;
    if (start != 0) {
      matches.add(YHMatch(0, start, false));
      end = start;
    } else if (start == 0) {
      end = start;
    }
    list.forEach((element) {
      if (element.start != end) {
        matches.add(YHMatch(end, element.start, false));
      }
      matches.add(YHMatch(element.start, element.end, true));
      start = element.start;
      end = element.end;
    });

    if (end != text.length) {
      matches.add(YHMatch(end, text.length, false));
    }

    // print(matches);

    // matches.forEach((element) {
    //   print(" xxxxxxxxxx ${text.substring(element.start, element.end)} ${element.highlight}");
    // });
    return matches;
  }
}
