import 'package:flutter/material.dart';

/// 点击事件的封装
class PQTap extends StatelessWidget {
  const PQTap({
    Key? key,
    this.onTap,
    this.onTapCancel,
    this.onTapUp,
    this.onTapDown,
    this.onLongPress,
    this.onLongPressUp,
    this.onLongPressEnd,
    this.onLongPressStart,
    this.onDoubleTap,
    this.onDoubleTapCancel,
    this.onDoubleTapDown,
    this.child,
  }) : super(key: key);

  /// 点击
  final GestureTapCallback? onTap;
  /// 取消点击
  final GestureTapCallback? onTapCancel;
  /// 点击抬起
  final GestureTapUpCallback? onTapUp;
  /// 点击按下
  final GestureTapDownCallback? onTapDown;
  /// child
  final Widget? child;
  /// 长按
  final GestureTapCallback? onLongPress;
  /// 长按抬起
  final GestureTapCallback? onLongPressUp;
  /// 长按结束
  final GestureLongPressEndCallback? onLongPressEnd;
  /// 长按开始
  final GestureLongPressStartCallback? onLongPressStart;
  /// 双击
  final GestureTapCallback? onDoubleTap;
  /// 双击取消
  final GestureTapCancelCallback? onDoubleTapCancel;
  /// 双击按下
  final GestureTapDownCallback? onDoubleTapDown;

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
      onTap: onTap,
      onTapUp: onTapUp,
      onTapDown: onTapDown,
      onTapCancel: onTapCancel,
      onDoubleTap: onDoubleTap,
      onDoubleTapCancel: onDoubleTapCancel,
      onDoubleTapDown: onDoubleTapDown,
      onLongPress: onLongPress,
      onLongPressUp: onLongPressUp,
      onLongPressEnd: onLongPressEnd,
      onLongPressStart: onLongPressStart,
      child: child,
    );
  }
}
